import youtube_dl
# from threading import Thread
import threading

from flask import render_template


def call_youtubedl(url):
    print(url)
    download_audio(url)
    # thread = Thread(args=(, ))
    thread = threading.Thread(target=download_audio, args=(url, "first_test"), daemon=True)
    thread.start()
    thread.join()

    # loading screen based on https://github.com/Aycn0/flask_loading_screen
    # data = "test"
    # return render_template('success.html', passed_data=data)

    # print("thread finished...exiting")

def download_audio(url):
    ydl_opts = {
        'format': 'bestaudio/best',
        'outtmpl': f'/output/%(title)s.mp3', # Template for output names. Needed to change the file extension
        'noplaylist': True, # Download only the video, if the URL refers to a video and a playlist
        'continue_dl': True, # Force resume of partially downloaded files. By default, youtube-dl will resume downloads if possible
        'postprocessors': [{
            'key': 'FFmpegExtractAudio',
            'preferredcodec': 'mp3',
            'preferredquality': '192', }]
    }
    try:
        with youtube_dl.YoutubeDL(ydl_opts) as ydl:
            ydl.cache.remove()
            info_dict = ydl.extract_info(url, download=False)
            ydl.prepare_filename(info_dict)
            ydl.download([url])
            return True
    except Exception:
        return False
